VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsINI"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'*************************************************************************
'*                        INI-                     *
'*-----------------------------------------------------------------------*
'*       :                                                       *
'*  AddSection     -                                 *
'*  AddValue       -                        *
'*  Filename       -  .   ,  .    *
'*  RemoveSection  -                                        *
'*  RemoveValue    -                              *
'*  SectionExists  -  True,                *
'*  SectionName    -                        *
'*  SectionsCount  -                           *
'*  UpdateFile     -                                        *
'*  Value          - /           *
'*  ValueExists    -  True,              *
'*  ValueName      -                    *
'*  ValuesCount    -        *
'*-----------------------------------------------------------------------*
'*                          17  2000  10:43                          *
'*         Copyright  2000   <Dmitriy@e-mail.ru>          *
'*************************************************************************
Option Explicit

'    True,   

Private mFilename As String

Private AllSections() As tSection

Private Type tValue
    Name As String
    cntValue As String
End Type
Private Type tSection
    Name As String
    Values() As tValue
End Type
Public Function RemoveSection(ByVal Section As String) As Boolean
Dim i&, uSN$, a&
uSN = UCase$(Section)
'   
For i = 1 To UBound(AllSections)
    If UCase$(AllSections(i).Name) = uSN Then
        '   ,   ""
        For a = i To UBound(AllSections) - 1
            AllSections(a) = AllSections(a + 1)
        Next a
        ' 
        ReDim Preserve AllSections(UBound(AllSections) - 1)
        RemoveSection = True
        Exit Function
    End If
Next i
End Function
Public Property Get SectionExists(ByVal Section As String) As Boolean
Dim i&, uSN$
uSN = UCase$(Section)
'       ,   
For i = 1 To UBound(AllSections)
    If UCase$(AllSections(i).Name) = uSN Then
        ' !
        SectionExists = True
        Exit Property
    End If
Next i
End Property
Public Function UpdateFile() As Boolean
'     -  -? :)
If Len(mFilename) = 0 Then Exit Function
Dim i&, a&
Open mFilename For Output Access Write Lock Write As #1
For i = 1 To UBound(AllSections)
    '   
    With AllSections(i)
        Print #1, "[" & .Name & "]"
        '     
        For a = 1 To UBound(.Values)
            Print #1, .Values(a).Name & "=" & .Values(a).cntValue
        Next a
    End With
    Print #1, vbNullString
Next i
Close #1
UpdateFile = True
End Function
Public Property Get ValueExists(ByVal Section As String, ByVal ValueName As String) As Boolean
Dim i&, uSN$, uVN$, a&
uSN = UCase$(Section)
uVN = UCase$(ValueName)
'   
For i = 1 To UBound(AllSections)
    If UCase$(AllSections(i).Name) = uSN Then
        '  ,     
        For a = 1 To UBound(AllSections(i).Values)
            If AllSections(i).Values(a).Name = uVN Then
                '  
                ValueExists = True
                Exit Property
            End If
        Next a
        Exit Property
    End If
Next i
End Property
Public Property Get ValueName(ByVal Section As String, ByVal Index As Long) As String
' :       ,  
'  vbNullChar -    
Dim uSN$, i&
uSN = UCase$(Section)
'   
For i = 1 To UBound(AllSections)
    If UCase$(AllSections(i).Name) = uSN Then
        ' 
        If Index > 0 And Index <= UBound(AllSections(i).Values) Then
            '  
            ValueName = AllSections(i).Values(Index).Name
            Exit Property
        Else
            '    ...
            ValueName = vbNullChar
        End If
        Exit Property
    End If
Next
ValueName = vbNullChar
End Property
Public Function RemoveValue(ByVal Section As String, ByVal ValueName As String) As Boolean
Dim i&, a&, uVN$, uSN$, c&
uSN = UCase$(Section)
uVN = UCase$(ValueName)
'   
For i = 1 To UBound(AllSections)
    If UCase$(AllSections(i).Name) = uSN Then
        '   
        For a = 1 To UBound(AllSections(i).Values)
            If UCase$(AllSections(i).Values(a).Name) = uVN Then
                '   
                With AllSections(i)
                    '   ""  
                    For c = a To UBound(.Values) - 1
                        .Values(a) = .Values(a + 1)
                    Next c
                    '  
                    ReDim Preserve .Values(UBound(.Values) - 1)
                    RemoveValue = True
                    Exit Function
                End With
            End If
        Next
        Exit Function
    End If
Next i
End Function
Public Function AddValue(ByVal Section As String, ByVal ValueName As String, Optional ByVal lValue As String = vbNullString) As Boolean
Dim uSN$, i&, uVN$, a&
uSN = UCase$(Section)
uVN = UCase$(ValueName)
' -  ...
For i = 1 To UBound(AllSections)
    If UCase$(AllSections(i).Name) = uSN Then
add_value:
        '   !
        For a = 1 To UBound(AllSections(i).Values)
            If UCase$(AllSections(i).Values(a).Name) = uVN Then
                '    
                Exit Function
            End If
        Next a
        '   
        With AllSections(i)
            ReDim Preserve .Values(UBound(.Values) + 1)
            .Values(UBound(.Values)).Name = ValueName
            .Values(UBound(.Values)).cntValue = lValue
        End With
        AddValue = True
        Exit Function
    End If
Next i
'   , ...
AddSection Section
GoTo add_value
End Function
Public Property Get ValuesCount(ByVal Section As String) As Long
' :    ,  
'  -1.
Dim uSN$, i&
uSN = UCase$(Section)
'   
For i = 1 To UBound(AllSections)
    If UCase$(AllSections(i).Name) = uSN Then
        '  
        ValuesCount = UBound(AllSections(i).Values)
        Exit Property
    End If
Next
ValuesCount = -1
End Property
Public Property Let Value(ByVal Section As String, ByVal ValueName As String, ByVal vData As String)
Dim i&, a&, uVN$, uSN$
uSN = UCase$(Section)
uVN = UCase$(ValueName)
'   
For i = 1 To UBound(AllSections)
    If UCase$(AllSections(i).Name) = uSN Then
        '    
        For a = 1 To UBound(AllSections(i).Values)
            If UCase$(AllSections(i).Values(a).Name) = uVN Then
                '  ,   ...
                AllSections(i).Values(a).cntValue = vData
                Exit Property
            End If
        Next
        '   ,  ...
        With AllSections(i)
            ReDim Preserve .Values(UBound(.Values) + 1)
            .Values(UBound(.Values)).cntValue = vData
            .Values(UBound(.Values)).Name = ValueName
        End With
        Exit Property
    End If
Next i
'    ,  ...
ReDim Preserve AllSections(UBound(AllSections) + 1)
With AllSections(UBound(AllSections))
    .Name = Section
    ReDim .Values(1)
    .Values(1).Name = ValueName
    .Values(1).cntValue = vData
End With
End Property
Public Property Get Value(ByVal Section As String, ByVal ValueName As String) As String
' :     ,  
'  vbNullChar -    
Dim i&, a&, uVN$, uSN$
uSN = UCase$(Section)
uVN = UCase$(ValueName)
'   
For i = 1 To UBound(AllSections)
    If UCase$(AllSections(i).Name) = uSN Then
        '     
        For a = 1 To UBound(AllSections(i).Values)
            If UCase$(AllSections(i).Values(a).Name) = uVN Then
                '   
                Value = AllSections(i).Values(a).cntValue
                Exit Property
            End If
        Next
        Value = vbNullChar
        Exit Property
    End If
Next i
Value = vbNullChar
End Property
Public Property Get SectionName(ByVal Index As Long) As String
'   :  -     
'     .
' :     ,  
'  vbNullChar -    
If Index > 0 And Index <= UBound(AllSections) Then
    SectionName = AllSections(Index).Name
Else
    SectionName = vbNullChar
End If
End Property
Public Function AddSection(ByVal Section As String) As Boolean
Dim uSN$, i&
uSN = UCase$(Section)
For i = 1 To UBound(AllSections)
    If UCase$(AllSections(i).Name) = uSN Then
        '    ...
        Exit Function
    End If
Next i
'     
ReDim Preserve AllSections(UBound(AllSections) + 1)
With AllSections(UBound(AllSections))
    .Name = Section
    ReDim .Values(0)
End With
AddSection = True
End Function
Public Property Get SectionsCount() As Long
SectionsCount = UBound(AllSections)
End Property
Public Property Let FileName(ByVal vData As String)
Dim s&, v&, l$, t&
mFilename = vData
ReDim AllSections(0)
'   ?
If Len(Dir(mFilename)) = 0 Then
    '  , ...
    Exit Property
End If
'  
Open mFilename For Input Access Read Lock Write As #1
Do While Not EOF(1)
    Line Input #1, l
    '  ?
    t = InStr(1, l, ";")
    l = LTrim$(RTrim$(l))
    '   
    If t = 1 Or Len(l) = 0 Then GoTo skip_line
    '    
    If t > 1 Then l = Left$(l, t - 1)
    If Left$(l, 1) = "[" Then
        '  
        t = InStr(1, l, "]")
        If t < 3 Then GoTo skip_line
        l = Mid$(l, 2, t - 2)
        '     
        s = s + 1
        '      
        v = 0
        ReDim Preserve AllSections(s)
        AllSections(s).Name = l
        ReDim AllSections(s).Values(0)
    Else
        '    
        '         - 
        If s = 0 Then GoTo skip_line
        '         
        t = InStr(1, l, "=")
        If t < 2 Then GoTo skip_line
        v = v + 1
        '  
        With AllSections(s)
            ReDim Preserve .Values(v)
            .Values(v).Name = Left$(l, t - 1)
            If t < Len(l) Then .Values(v).cntValue = Mid$(l, t + 1, Len(l) - t)
        End With
    End If
skip_line:
Loop
Close #1
End Property
Public Property Get FileName() As String
FileName = mFilename
End Property
Private Sub Class_Initialize()
ReDim AllSections(0)
End Sub
Private Sub Class_Terminate()
ReDim AllSections(0)
End Sub

